<template>
    <v-alert v-if="showAlert" :title="title" :text="alertText" :type="alertType" :dismissible="10" variant="tonal"
        class="alert"></v-alert>
</template>
  
<script>
import { ref, defineComponent } from "vue";

export default defineComponent({
    props: {
        title: {
            type: String,
            required: true,
        },
        alertText: {
            type: String,
            required: true,
        },
        alertType: {
            type: String,
            required: true,
        },
    },
    setup() {
        const showAlert = ref(false);
        const dismissCountDown = ref(10);
        const dismissSecs = ref(10);
        const intervalId = ref(null);

        const showTimedAlert = () => {
            showAlert.value = true;
            intervalId.value = setInterval(() => {
                if (dismissCountDown.value > 0) {
                    dismissCountDown.value--;
                } else {
                    clearInterval(intervalId.value);
                    showAlert.value = false;
                    dismissCountDown.value = dismissSecs.value;

                }
            }, 1000);
        };
        return {
            showAlert,
            dismissCountDown,
            dismissSecs,
            intervalId,
            showTimedAlert,
        };
    },
});
</script>
<style scoped>
.v-alert--density-default {
    padding-bottom: 16px;
    padding-top: 16px;
    display: -webkit-inline-box;
    position: fixed;
    bottom: 20px;
    right: 20px;
    font-size: 14px;
    font-family: emoji;
}

.alert {
    margin-bottom: 10px;
    animation: slideRight 0.5s ease-in-out, fadeIn 12s ease-in-out;
    opacity: 1;
}

@keyframes slideRight {
    0% {
        transform: translateX(-100%);
    }

    100% {
        transform: translateX(0);
    }
}

@keyframes fadeIn {
    0% {
        opacity: 1;
    }

    100% {
        opacity: 0;
    }
}
</style>
  